#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define R 10000
#define Q 0.8

int maximum(int a,int b);

int main(int argc, char *argv[])
{
	int i,j;
	int Line=0;
	int max=0;
	int x,y;
	int flag=0;
	
	int all=0;
	double autsum,hubsum;
	
	int *ll,*lr;
	int *filter;
	double *aut,*hub;
	double *aaa,*hhh;
	
	ll=(int *)calloc(1,sizeof(int));
	lr=(int *)calloc(1,sizeof(int));
	filter=(int *)calloc(1,sizeof(int));
	
	Line=1;
	max=0;
	
	FILE *fp;
	//argv[1] : list file to read
	fp=fopen(argv[1],"r");
	while(fscanf(fp,"%d %d",&x,&y)!=EOF)
	{
	max=maximum(max,x);
	max=maximum(max,y);
	ll=(int *)realloc(ll,(Line+1)*sizeof(int));
	lr=(int *)realloc(lr,(Line+1)*sizeof(int));
	ll[Line]=x;
	lr[Line]=y;
	Line++;
	}
	fclose(fp);
	//finish reading the list
	
	max++;
	filter=(int *)realloc(filter,(max+1)*sizeof(int));
	for(i=1;i<Line;i++)
	{
		filter[ll[i]]=1;
		filter[lr[i]]=1;
	}
	//////////initial////////
	aut=(double *)calloc(max,sizeof(double));	// authority
	aaa=(double *)calloc(max,sizeof(double));	// tmp variable
	hub=(double *)calloc(max,sizeof(double));	// hub
	hhh=(double *)calloc(max,sizeof(double));	// tmp variable

	//To calculate the authority , give the initial Hub number
	for(i=1;i<max;i++)
	{
		if(filter[i]>0)
		{
		hub[i]=1.0;
		aut[i]=0;
		all+=1;
		}
	}
	
	hubsum=1.0;
	
	//Repeat
	for(j=0;j<R;j++)
	{
	
		for(i=1;i<max;i++)
		{
			aaa[i]=aut[i];
			hhh[i]=hub[i];
		}
		
		flag=0;
		
	////////Update//////
	
		for(i=1;i<Line;i++)
		{
			aut[lr[i]]+=hub[ll[i]];
		}
	
	///////Normalization
	
	autsum=0;
	
	for(i=1;i<max;i++)
	{
		if(filter[i]>0)
		{
		aut[i]=aut[i]*Q+(1.0-Q)/all;
		autsum+=pow(aut[i],2.0);
		}
	}
	
	for(i=1;i<max;i++)
	{
		aut[i]=aut[i]/(pow(autsum,0.5));
	}
	
	////////Hub
	
	hubsum=0;
	for(i=1;i<Line;i++)
	{
		hub[ll[i]]+=aut[lr[i]];
	}
	for(i=1;i<max;i++)
	{
		if(filter[i]>0)
		{
		hub[i]=hub[i]*Q+(1.0-Q)/all;
		hubsum+=pow(hub[i],2.0);
		}
	}	
	for(i=1;i<max;i++)
	{
		hub[i]=hub[i]/(pow(hubsum,0.5));
	}
	
	for(i=1;i<max;i++)
	{
		if(filter[i]>0 && fabs(hub[i]-hhh[i])<0.000001 && fabs(aut[i]-aaa[i])<0.000001)
		{flag++;}
	}
	
		//printf("%d %d %d %f %f\n",j,all,flag,*(aut+1),*(hub+1));
		
		if(flag==all)
		{break;}
	}	
	
	for(i=1;i<max;i++)
	{
		if(filter[i]>0)
		{
		printf("%d %f %f\n",i,aut[i],hub[i]);
		}
	}

	free(ll);
	free(lr);
	free(filter);
	free(aut);
	free(aaa);
	free(hub);
	free(hhh);	
}

int maximum(int a,int b)
{
	if(a>b)
	{
		return(a);
	}else{
		return(b);
	}
	
}